; ruff'n tumble original boot
STARS

D_init=$8200
D_priB=$400
D_Btpl=$100
D_Copp=$80
D_Blit=$40
D_sprt=$20
D_disk=$10


aDos:		dc.b 'DOS',0
		dc.l 0		; checksum
		dc.l $370		; root

StartBoot:				; save trackdisk.device
	bsr	Crk
		move.l	a1,-(sp)
		move.l	#11*512,d0
		move.l	#$10002,d1
		movea.l	4.w,a6
		jsr	-$C6(a6)	; allocmem
		movea.l	d0,a3		; buffer
		movea.l	(sp)+,a1	; restore trackdisk.device
		tst.l	d0
		beq.s	_errormem
		movea.l	a1,a2

_load:
		move.l	a3,40(a1)	; buffer
		move.l	#11*512,36(a1)	; len 11*512
		move.l	#24*512,44(a1)	; offset 24*512
		move.w	#2,28(a1)	; lecture
		movea.l	4.w,a6
		jsr	-456(a6)	; DoIO
		movea.l	a2,a1		; trackdisk.device
		move.b	31(a1),d0
		bne.s	_load		; buffer
		lea	patch(pc),a0
		lea	$77c(a3),a1
		moveq	#s-1,d7
.copy	move.b	(a0)+,(a1)+
	dbf	d7,.copy
	lea	flagtr(pc),a1
	tst.w	(a1)
	beq.s	.notrainer
	move.l	#$140,$114(a3)	; JMP $804 -> JMP $140
	lea	Trainer(pc),a0
	lea	$140.w,a1
	move.l	#sizetr-1,d7
.copy2	move.b	(a0)+,(a1)+
	dbf	d7,.copy2
.notrainer	movea.l	8.l,a5
		jmp	(a3)		; exec

_errormem:
		moveq	#-1,d0
		rts
patch	move.l	#$BED7B57D,d0
	move.l	d0,(a3)
	rts
s=*-patch
; base $140
Trainer:	
	move.w	#$14E,$50056	; jsr $166
	jmp	$50000
; $14E
patchmain:
	move.l	#$4EB80166,$B70.w ; jsr $166
	move.l	#$4E714E71,$B74.w ; nop nop
	jmp	$804.w

; $162
ad3968:	dc.l 0

; $166
sub_0_166:
	movea.l	$3968.w,a5	; original code
	move.l	(a5),d7
; patch keyboard routine
	movem.l	d0-a6,-(sp)
	adda.l	d7,a5
	move.l	a5,$162.w
	move.w	#$19,d0
	lea	InGameKeyboard(pc),a0
	lea	$93C.w,a1	; original keyboard routine
	move.w	#$4EB8,(a1)+	; jsr
	move.w	a0,(a1)+
	movem.l	(sp)+,d0-a6
	rts

InGameKeyboard:
	move.b	$BFEC01,d0
	movem.l	d0-d1/a0-a1,-(sp)
	movea.l	$162.w,a1
	move.b	d0,d1		; key
	not.b	d1
	ror.b	#1,d1
; L/H/I
toggleLive:
	move.w	#$19,d0
	cmp.b	#$28,d1		; L
	bne.s	toggleHealth
	eor.b	d0,$40A4(a1)

toggleHealth:
	cmp.b	#$25,d1		; H
	bne.s	toggleInvulnerability
	eor.b	d0,$39D8(a1)

toggleInvulnerability:
	cmp.b	#$17,d1		; I
	bne.s	weapon1
	eori.b	#7,$39D6(a1)
	eori.b	#7,$3A26(a1)

; F1/F7 : weapon select
weapon1:
	cmp.b	#$50,d1		; F1
	bne.s	weapon2
	move.w	#0,$3E36.w
weapon2:
	cmp.b	#$51,d1		; F2
	bne.s	weapon3
	move.w	#1,($3E36).w
weapon3:
	cmp.b	#$52,d1		; F3
	bne.s	weapon4
	move.w	#2,$3E36.w
weapon4:
	cmp.b	#$53,d1		; F4
	bne.s	weapon5
	move.w	#3,$3E36.w
weapon5:
	cmp.b	#$54,d1		; F5
	bne.s	weapon6
	move.w	#4,$3E36.w
weapon6:
	cmp.b	#$55,d1		; F6
	bne.s	weapon7
	move.w	#5,$3E36.w
weapon7:
	cmp.b	#$56,d1		; F7
	bne.s	OpenExit
	move.w	#6,($3E36).w

; DEL/HELP
OpenExit:
	cmp.b	#$46,d1		; DEL
	bne.s	SkipLevel
	clr.l	$3E44.w
	clr.w	$3E48.w
SkipLevel:
	cmp.b	#$5F,d1		; HELP
	bne.s	CollectKeys
	move.w	#$14,$5A2(a1)
; K/F
CollectKeys:
	cmp.b	#$27,d1		; K
	bne.s	toggleFloatClimb
	move.l	#$30003,$3E3C.w

toggleFloatClimb:
	cmp.b	#$23,d1		; F
	bne.s	exit
	eori.b	#6,$426E(a1)

exit:	movem.l	(sp)+,d0-d1/a0-a1
	rts
flagtr	dc.w	0
;	dc.b 'Trained By Gradius/Anthrox! 22/10/94 '
;	even
sizetr=*-Trainer
;-------------------------------------------------------------
Crk:	movem.l	d0-a6,-(sp)
	ifd	STARS
	movea.l	#$72000,a0
	move.w	#($7E000-$72000)/4-1,d0
.clear:	clr.l	(a0)+
	dbf	d0,.clear

;	bsr	writer

	lea	copperlist(pc),a0
	move.l	a0,$DFF080
	move.l	#0,$dff088

	move.w	#316-1,d3
	movea.l	#$7E000,a0	; bufstars
initstars:
	bsr	random
	move.w	d0,(a0)+
	bsr	random
	move.w	d0,(a0)+
	bsr	random
	andi.w	#$1FF,d0
	move.w	d0,(a0)+
	dbf	d3,initstars

MainLoop:
	cmpi.b	#212,$dff006
	bne.s	MainLoop
	bsr	Stars
	btst	#2,$dff016
	bne.s	.lmb
	lea	flagtr(pc),a1
	move.w	#-1,(a1)
	bra.s	.exit
.lmb	btst	#6,$BFE001
	bne.s	MainLoop

.exit	move.w	#$180,$dff096
	move.w	#0,$dff100
	endc
	movem.l	(sp)+,d0-a6
	rts
; ---------------------------------------------------
	ifd	STARS
writer:	lea	$78000,a0
	lea	text(pc),a1
	rts
Stars:	movea.l	#$7E000,a4
	move.w	#316-1,d3	; nb stars
	movea.l	#$7E000+$800,a5
loopstars:
	move.w	(a4)+,d4
	move.w	(a4)+,d5
	move.w	(a4),d6
	subq.w	#2,(a4)+
	tst.w	d6
	ble.s	newstar
	ext.l	d4
	divs.w	d6,d4
	addi.w	#152,d4		; xcenter
	ext.l	d5
	divs.w	d6,d5
	addi.w	#128,d5		; ycenter
	tst.w	d4
	blt.s	newstar
	tst.w	d5
	blt.s	newstar
	cmpi.w	#319,d4
	bgt.s	newstar
	cmpi.w	#272,d5
	bgt.s	newstar
	move.w	(a5),d0
	move.w	d4,(a5)+
	move.w	(a5),d1
	move.w	d5,(a5)+
	bsr.s	offsets
	movea.l	#$72000,a1
	adda.l	d1,a1
	bclr	d2,(a1)
	movea.l	#$75000,a1
	adda.l	d1,a1
	bclr	d2,(a1)
	move.w	d4,d0
	move.w	d5,d1
	bsr.s	offsets
	cmpi.w	#400,d6
	bgt.s	plan1
	cmpi.w	#300,d6
	bgt.s	plan2
	bra.s	plan1_2
newstar:
	subq.l	#6,a4
	bsr.s	random
	move.w	d0,(a4)+
	bsr.s	random
	move.w	d0,(a4)+
	move.w	#600,(a4)+
	bra.s	next

plan1	movea.l	#$72000,a1
	bra.s	plot

plan2	movea.l	#$75000,a1
	bra.s	plot

plan1_2	movea.l	#$72000,a1
	adda.l	d1,a1
	bset	d2,(a1)
	movea.l	#$75000,a1

plot:	adda.l	d1,a1
	bset	d2,(a1)
next:
	dbf	d3,loopstars
	rts	

offsets	mulu.w	#40,d1
	move.w	d0,d2
	asr.w	#3,d2
	add.w	d2,d1
	asl.w	#3,d2
	sub.w	d0,d2
	subq.b	#1,d2
	rts

random:	move.w	$DFF006,d0
	lea	randomvalue(pc),a3
	muls.w	(a3),d0
	addi.w	#$1260,d0
	ext.l	d0
	move.w	d0,(a3)
	rts
randomvalue:	
	dc.w $7000
copperlist:	
	dc.w	$1fc,0,$106,$c00,$10c,$11	
	dc.l $8E2081
	dc.l $9030C1
	dc.l $920038
	dc.l $9400D0
	dc.l $1020000
	dc.l $1080000
	dc.l $10A0000
	dc.l $1040000
	dc.l $968100
	dc.l $E00007		; 72000
	dc.l $E22000
	dc.l $E40007		; 75000
	dc.l $E65000
;	dc.l $E80007		; 78000
;	dc.l $EA8000
	dc.l $1002200
	dc.l $1800000
	dc.l $1820335
	dc.l $1840668
	dc.l $1860AAC
	dc.l $188000F
	dc.l $18a000F
	dc.l $18c000F
	dc.l $18e000F
	dc.l $FFFFFFFE
	endc
	END
