; ruff'n tumble original boot


aDos:		dc.b 'DOS',0
		dc.l 0		; checksum
		dc.l $370		; root

StartBoot:				; save trackdisk.device
		move.l	a1,-(sp)
		move.l	#11*512,d0
		move.l	#$10002,d1
		movea.l	4.w,a6
		jsr	-$C6(a6)	; allocmem
		movea.l	d0,a3		; buffer
		movea.l	(sp)+,a1	; restore trackdisk.device
		tst.l	d0
		beq.s	_errormem
		movea.l	a1,a2

_load:
		move.l	a3,40(a1)	; buffer
		move.l	#11*512,36(a1)	; len 11*512
		move.l	#24*512,44(a1)	; offset 24*512
		move.w	#2,28(a1)	; lecture
		movea.l	4.w,a6
		jsr	-456(a6)	; DoIO
		movea.l	a2,a1		; trackdisk.device
		move.b	31(a1),d0
		bne.s	_load		; buffer
		lea	patch(pc),a0
		lea	$77c(a3),a1
		moveq	#s-1,d7
.copy	move.b	(a0)+,(a1)+
	dbf	d7,.copy
	btst	#2,$dff016
	bne.s	.notrainer
	move.l	#$140,$114(a3)	; JMP $804 -> JMP $140
	lea	Trainer(pc),a0
	lea	$140.w,a1
	move.l	#sizetr-1,d7
.copy2	move.b	(a0)+,(a1)+
	dbf	d7,.copy2
.notrainer	movea.l	8.l,a5
		jmp	(a3)		; exec

_errormem:
		moveq	#-1,d0
		rts
crk:	
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
		dc.b	0 ;  
aCopylockAmigaC:dc.b 'Copylock Amiga (c)1988-90 Rob Northen Computing, U.K. All '
		dc.b 'Rights Reserved.',0
		even
patch	move.l	#$BED7B57D,d0
	move.l	d0,(a3)
	rts
s=*-patch
; base $140
Trainer:	
	move.w	#$14E,$50056	; jsr $166
	jmp	$50000
; $14E
patchmain:
	move.l	#$4EB80166,$B70.w ; jsr $166
	move.l	#$4E714E71,$B74.w ; nop nop
	jmp	$804.w

; $162
ad3968:	dc.l 0

; $166
sub_0_166:
	movea.l	$3968.w,a5	; original code
	move.l	(a5),d7
; patch keyboard routine
	movem.l	d0-a6,-(sp)
	adda.l	d7,a5
	move.l	a5,$162.w
	move.w	#$19,d0
	lea	InGameKeyboard(pc),a0
	lea	$93C.w,a1	; original keyboard routine
	move.w	#$4EB8,(a1)+	; jsr
	move.w	a0,(a1)+
	movem.l	(sp)+,d0-a6
	rts

InGameKeyboard:
	move.b	$BFEC01,d0
	movem.l	d0-d1/a0-a1,-(sp)
	movea.l	$162.w,a1
	move.b	d0,d1		; key
	not.b	d1
	ror.b	#1,d1
; L/H/I
toggleLive:
	move.w	#$19,d0
	cmp.b	#$28,d1		; L
	bne.s	toggleHealth
	eor.b	d0,$40A4(a1)

toggleHealth:
	cmp.b	#$25,d1		; H
	bne.s	toggleInvulnerability
	eor.b	d0,$39D8(a1)

toggleInvulnerability:
	cmp.b	#$17,d1		; I
	bne.s	weapon1
	eori.b	#7,$39D6(a1)
	eori.b	#7,$3A26(a1)

; F1/F7 : weapon select
weapon1:
	cmp.b	#$50,d1		; F1
	bne.s	weapon2
	move.w	#0,$3E36.w
weapon2:
	cmp.b	#$51,d1		; F2
	bne.s	weapon3
	move.w	#1,($3E36).w
weapon3:
	cmp.b	#$52,d1		; F3
	bne.s	weapon4
	move.w	#2,$3E36.w
weapon4:
	cmp.b	#$53,d1		; F4
	bne.s	weapon5
	move.w	#3,$3E36.w
weapon5:
	cmp.b	#$54,d1		; F5
	bne.s	weapon6
	move.w	#4,$3E36.w
weapon6:
	cmp.b	#$55,d1		; F6
	bne.s	weapon7
	move.w	#5,$3E36.w
weapon7:
	cmp.b	#$56,d1		; F7
	bne.s	OpenExit
	move.w	#6,($3E36).w

; DEL/HELP
OpenExit:
	cmp.b	#$46,d1		; DEL
	bne.s	SkipLevel
	clr.l	$3E44.w
	clr.w	$3E48.w
SkipLevel:
	cmp.b	#$5F,d1		; HELP
	bne.s	CollectKeys
	move.w	#$14,$5A2(a1)
; K/F
CollectKeys:
	cmp.b	#$27,d1		; K
	bne.s	toggleFloatClimb
	move.l	#$30003,$3E3C.w

toggleFloatClimb:
	cmp.b	#$23,d1		; F
	bne.s	exit
	eori.b	#6,$426E(a1)

exit:	movem.l	(sp)+,d0-d1/a0-a1
	rts
	dc.b 'Trained By Gradius/Anthrox! 22/10/94 '
	even
sizetr=*-Trainer
		END
